/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import {exists, mapValues} from '../runtime';
/**
 *
 * @export
 * @interface CloudEvent
 */
export interface CloudEvent {
  /**
   *
   * @type {object}
   * @memberof CloudEvent
   */
  data?: object;
  /**
   *
   * @type {string}
   * @memberof CloudEvent
   */
  id?: string;
  /**
   *
   * @type {string}
   * @memberof CloudEvent
   */
  type?: string;
  /**
   *
   * @type {Date}
   * @memberof CloudEvent
   */
  time?: Date;
  /**
   *
   * @type {string}
   * @memberof CloudEvent
   */
  source?: string;
  /**
   *
   * @type {Set<string>}
   * @memberof CloudEvent
   */
  attributeNames?: Set<string>;
  /**
   *
   * @type {string}
   * @memberof CloudEvent
   */
  subject?: string;
  /**
   *
   * @type {string}
   * @memberof CloudEvent
   */
  dataContentType?: string;
  /**
   *
   * @type {string}
   * @memberof CloudEvent
   */
  dataSchema?: string;
  /**
   *
   * @type {string}
   * @memberof CloudEvent
   */
  specVersion?: CloudEventSpecVersionEnum;
  /**
   *
   * @type {Set<string>}
   * @memberof CloudEvent
   */
  extensionNames?: Set<string>;
}

/**
 * @export
 */
export const CloudEventSpecVersionEnum = {
  _03: '0.3',
  _10: '1.0',
} as const;
export type CloudEventSpecVersionEnum =
  typeof CloudEventSpecVersionEnum[keyof typeof CloudEventSpecVersionEnum];

export function CloudEventFromJSON(json: any): CloudEvent {
  return CloudEventFromJSONTyped(json, false);
}

export function CloudEventFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): CloudEvent {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    data: !exists(json, 'data') ? undefined : json['data'],
    id: !exists(json, 'id') ? undefined : json['id'],
    type: !exists(json, 'type') ? undefined : json['type'],
    time: !exists(json, 'time') ? undefined : new Date(json['time']),
    source: !exists(json, 'source') ? undefined : json['source'],
    attributeNames: !exists(json, 'attributeNames')
      ? undefined
      : json['attributeNames'],
    subject: !exists(json, 'subject') ? undefined : json['subject'],
    dataContentType: !exists(json, 'dataContentType')
      ? undefined
      : json['dataContentType'],
    dataSchema: !exists(json, 'dataSchema') ? undefined : json['dataSchema'],
    specVersion: !exists(json, 'specVersion') ? undefined : json['specVersion'],
    extensionNames: !exists(json, 'extensionNames')
      ? undefined
      : json['extensionNames'],
  };
}

export function CloudEventToJSON(value?: CloudEvent | null): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    data: value.data,
    id: value.id,
    type: value.type,
    time: value.time === undefined ? undefined : value.time.toISOString(),
    source: value.source,
    attributeNames: value.attributeNames,
    subject: value.subject,
    dataContentType: value.dataContentType,
    dataSchema: value.dataSchema,
    specVersion: value.specVersion,
    extensionNames: value.extensionNames,
  };
}
